package com.zksy.web.controller.basicData;


import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmSocialInsuranceArrearsInfo;
import com.zksy.system.basicData.service.CrmSocialInsuranceArrearsInfoService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 社会保险费欠缴信息Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmSocialInsuranceArrearsInfo")
@Api(tags = "社会保险费欠缴信息", description = "社会保险费欠缴信息desc")
public class CrmSocialInsuranceArrearsInfoController extends BaseController {

    @Autowired
    private CrmSocialInsuranceArrearsInfoService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "社会保险费欠缴信息搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "社会保险费欠缴信息分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "社会保险费欠缴信息查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增社会保险费欠缴信息
     */
    @PostMapping("/save")
    @ApiOperation(value = "社会保险费欠缴信息新增")
    @Log(title = "新增社会保险费欠缴信息", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmSocialInsuranceArrearsInfo crmSocialInsuranceArrearsInfo) {
        return service.save(crmSocialInsuranceArrearsInfo);
    }

    /**
     * 修改社会保险费欠缴信息
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "社会保险费欠缴信息修改")
    @Log(title = "修改社会保险费欠缴信息", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmSocialInsuranceArrearsInfo crmSocialInsuranceArrearsInfo) {
        return service.updateById(crmSocialInsuranceArrearsInfo);
    }

    /**
     * 导入社会保险费欠缴信息
     */
    @ApiOperation("社会保险费欠缴信息导入")
    @Log(title = "社会保险费欠缴信息", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmSocialInsuranceArrearsInfo> crmSocialInsuranceArrearsInfoAll = service.list();
            List<CrmSocialInsuranceArrearsInfo> list = ExcelUtils.readMultipartFile(file, CrmSocialInsuranceArrearsInfo.class,CrmSocialInsuranceArrearsInfo.class.getDeclaredFields().length - 2);
            if(crmSocialInsuranceArrearsInfoAll != null && crmSocialInsuranceArrearsInfoAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("社会保险费欠缴信息导出")
    @Log(title = "社会保险费欠缴信息", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmSocialInsuranceArrearsInfo> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"社会保险费欠缴信息",wrapperList,CrmSocialInsuranceArrearsInfo.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "社会保险费欠缴信息", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除社会保险费欠缴信息", notes = "删除社会保险费欠缴信息")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"社会保险费欠缴信息模板");
    }
}

